/*
 * CPZipStripper 2.0
 * Written by Decebal Mihailescu [http://www.codeproject.com/script/articles/list_articles.asp?userid=634640]
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace CPZipStripper
{
    static class WildCharTextUtility
    {
        public static string strtxt;
        private static bool bCaseSensitive = false;
        public static string strpattern;
        static uint txtlen = 0;
        static uint patternlen = 0;
        static int last = -1;
        static int first = -1;

        private static char ConvertCase(char c)
        {
            return bCaseSensitive ? c : char.ToUpper(c);
        }
        //the workhorse of this class
        private static bool _PatternMatched(int IndexText, int IndexPattern)
        {
            while (true)
            {
                char CrtTxtChar, CrtPatternChar;
                CrtPatternChar = (IndexPattern == patternlen) ? '*' : ConvertCase(strpattern[IndexPattern++]);
                switch (CrtPatternChar)
                {
                    case '*':
                        if (IndexPattern == patternlen)//last *, used by FindPatternPosition
                        {
                            last = IndexText;

                            return true;// last pattern char == *, no need to check the last chars
                        }

                        while (IndexText < txtlen)
                        {
                            if (_PatternMatched(IndexText++, IndexPattern))
                            {
                                return true;
                            }
                        }
                        return false;

                    case '?':
                        if (IndexText == txtlen)
                            return false;
                        IndexText++;
                        break;
                    default:

                        if (IndexText == txtlen)
                            CrtTxtChar = '\0';
                        else
                            CrtTxtChar = ConvertCase(strtxt[IndexText++]);
                        if (CrtTxtChar != CrtPatternChar)            // check for exact char
                        {
                            if (CrtTxtChar == '\0')
                                return false;
                            else if (_PatternMatched(IndexText, 0))
                            {
                                if (first < IndexText)
                                    first = IndexText;
                                return true;
                            }
                            else
                                return false;
                        }
                        else
                        {
                            if (last < IndexText - 1)
                                last = IndexText - 1;
                        }

                        break;
                }//switch ends
            }//while ends
        }//_PatternMatched ends

        public static bool IsPatternMatch(ref string txt, ref string pat, bool casing)
        {
            strtxt = txt;
            txtlen = (uint)strtxt.Length;
            //eliminate leading *
            int index = 0;
            while (pat[index] == '*')
            {
                index++;
            }
            strpattern = pat.Substring(index);

            patternlen = (uint)strpattern.Length;
            bCaseSensitive = casing;
            {//fastest way
                if (strpattern.IndexOfAny("*?".ToCharArray()) < 0)
                {//that's a plain text serch
                    first = strtxt.LastIndexOf(strpattern);
                    if (first >= 0)
                        last = first + (int)patternlen;
                    return first >= 0;
                }
            }
            return _PatternMatched(0, 0);
        }

        public static bool IsPatternMatch(string txt, string pat)
        {
            bCaseSensitive = true;
            return IsPatternMatch(ref txt, ref pat, bCaseSensitive);
        }
    }
}
